/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Osoyoo Wifi Smart Home V2.0 Lesson 3-5
 * 
 * tutorial url: https://osoyoo.com/?p=40280
 */
#define BLYNK_PRINT Serial
#include <BlynkSimpleShieldEsp8266.h>
#include <ESP8266_Lib.h>
char auth[] = "0ByWpc50cmOJ5O6OyHMaK4OSHkDvUeI-";//replace this with your Blynk Token
char server_ip[]="192.168.1.81"; // replace this line with your Blynk Server IP address
// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "***";//replace this line with your wifi ssid
char pass[] = "***"; //replace this line with your wifi password
#include <SoftwareSerial.h>
SoftwareSerial EspSerial(A9, A8); // RX, TX
ESP8266 wifi(&EspSerial);
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

int distance, initialDistance, currentDistance, i;

#define echoPin 26
#define trigPin 25
#define BUTTON 10
#define LED   2 
#define buzzer  7 
int ButtonState;
int ButtonLastState;
int ButtonCounter;
LiquidCrystal_I2C lcd(0x27,16,2);

long getDistance () {
  Serial.println("HC-SR04 START!");
  float duration, distance;
  digitalWrite(trigPin, LOW); 
  delayMicroseconds(2);
 
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  
  duration = pulseIn(echoPin, HIGH);
  distance = (duration / 2) * 0.0344;
  Serial.print("Distance = ");
  Serial.print(distance);
  Serial.println(" cm");

  // You can send any value at any time.
  // Please don't send more that 10 values per second.
  //Blynk.virtualWrite(V4, distance);
  return distance;
}

void setup()
{
    pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
    lcd.init(); //initialize the lcd
  lcd.backlight(); //open the backlight 
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Press the button to"); // Print a message to the LCD.
lcd.setCursor(0, 1);
lcd.print("start the alarm!");  
  // Debug console
  Serial.begin(9600);
 while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("start");
  // set the data rate for the SoftwareSerial port
  EspSerial.begin(115200);
  EspSerial.write("AT+UART_DEF=9600,8,1,0,0\r\n");
  EspSerial.write("AT+RST\r\n");
  delay(100);
  EspSerial.begin(9600);

  Blynk.begin(auth, wifi, ssid, pass,server_ip,8080);
}

void loop()
{
  
  Blynk.run();
//  timer.run();

ButtonState = digitalRead(BUTTON);

  if(ButtonState != ButtonLastState)
  {
    if(ButtonState)
    {
       
        Serial.println("on");
        ButtonCounter++;
 lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Alarm Stop!"); // Print a message to the LCD.
lcd.setCursor(0, 1);
lcd.print("Press to start!");  
    }
    else
    {
      Serial.println("off");  

      

    }
    delay(100);
  }

  ButtonLastState = ButtonState;
  if(ButtonCounter%2)
  {
  return;

  
  }
  else
  {
    initialDistance = getDistance();
currentDistance = getDistance() + 10;
  lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Alarm Working!"); // Print a message to the LCD.
lcd.setCursor(0, 1);
lcd.print("Press to stop!");  
if ( currentDistance < initialDistance) {
   
    Serial.println("Sth at the door!");
    Blynk.notify("Sth at the door!");
    digitalWrite (LED,HIGH);
    digitalWrite (buzzer,HIGH);
    delay(3000);

  }
 
  else
  {
    digitalWrite (LED,LOW);
    digitalWrite (buzzer,LOW);
  }
 }
}
